<template>
  <div class="container-main" ref="main">
    <div class="search-hearder" ref="topSearch">
      <el-form
        :model="queryParams"
        ref="queryForm"
        :inline="true"
        v-show="showSearch"
        label-width="auto"
      >
        <el-form-item label="地区名称" prop="name">
          <el-input
            v-model="queryParams.name"
            placeholder="请输入地区名称"
            clearable
            size="small"
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div class="layui-table-tool" ref="tableTool">
      <el-button
        type="primary"
        size="mini"
        @click="handleAdd()"
        v-hasPermi="['zongzhi:attack:add']"
        >新增</el-button
      >
      <el-button
        type="success"
        size="mini"
        :disabled="single"
        @click="handleUpdate"
        v-hasPermi="['zongzhi:attack:edit']"
        >修改</el-button
      >
      <el-button
        type="danger"
        size="mini"
        :disabled="multiple"
        @click="handleDelete"
        v-hasPermi="['zongzhi:attack:remove']"
        >删除</el-button
      >
      <el-button
        type="warning"
        size="mini"
        :loading="exportLoading"
        @click="handleExport"
        v-hasPermi="['zongzhi:attack:export']"
        >导出</el-button
      >
    </div>
    <el-table
      v-loading="loading"
      :data="attackList"
      :height="tableHeigth"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="地区名称" align="center" prop="name" />
      <el-table-column label="攻击次数" align="center" prop="attackCount" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="200"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            @click="handleInfo(scope.row)"
            v-hasPermi="['zongzhi:attack:list']"
          >
            查看
          </el-button>
          <el-button
            type="success"
            size="mini"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['zongzhi:attack:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="danger"
            @click="handleDelete(scope.row)"
            v-hasPermi="['zongzhi:attack:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改地区受攻击对话框 -->
    <el-dialog
      :visible.sync="open"
      width="500px"
      append-to-body
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ title }}</div>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        label-width="auto"
        class="dialog-from"
      >
        <el-form-item label="地区名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入地区名称" />
        </el-form-item>
        <el-form-item label="攻击次数" prop="attackCount">
          <el-input v-model="form.attackCount" placeholder="请输入攻击次数" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--查看地区受攻击详情页-->
    <el-dialog
      :visible.sync="infoOpen"
      width="1200px"
      append-to-body
      :close-on-click-modal="false"
      :destroy-on-close="true"
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ infoTitle }}</div>

      <el-descriptions
        title="地区受攻击"
        :column="2"
        border
        labelClassName="desLable"
      >
        <el-descriptions-item label="地区名称">{{
          form.name
        }}</el-descriptions-item>

        <el-descriptions-item label="攻击次数">{{
          form.attackCount
        }}</el-descriptions-item>
      </el-descriptions>
    </el-dialog>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import {
  listAttack,
  getAttack,
  delAttack,
  addAttack,
  updateAttack,
  exportAttack,
} from "@/api/zongzhi/netSecurity/mapData/index.js";
export default {
  computed: {
    ...mapGetters(["townList", "treeProps"]),
  },
  name: "Attack",
  //注释字典
  data() {
    return {
      tableHeigth: 0,
      //查看详情
      infoOpen: false,
      //详情标题
      infoTitle: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 地区受攻击表格数据
      attackList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        name: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    // //给表格一个固定值
    this.$nextTick(() => {
      this.tableHeigth =
        this.$refs.main.offsetHeight -
        (this.$refs.topSearch.offsetHeight +
          this.$refs.tableTool.offsetHeight) -
        46;
      this.getList();
    });
  },
  methods: {
    /** 查询地区受攻击列表 */
    getList() {
      this.loading = true;
      listAttack(this.queryParams).then((response) => {
        this.attackList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,

        name: null,

        attackCount: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /**查看按钮操作 */
    handleInfo(row) {
      this.reset();
      const id = row.id || this.ids;
      getAttack(id).then((response) => {
        this.form = response.data;
        this.infoOpen = true;
        this.infoTitle = "查看地区受攻击详情";
      });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加地区受攻击";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getAttack(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改地区受攻击";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateAttack(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addAttack(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm(
        '是否确认删除地区受攻击编号为"' + ids + '"的数据项?',
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(function () {
          return delAttack(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有地区受攻击数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.download(
            "/zongzhi/attack/export",
            {
              ...this.queryParams,
            },
            "地区受攻击_" + new Date().getTime() + ".xlsx"
          );
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>
